//#define MAME

#ifdef MAME

  #include "mamalleg.h"
  #include "driver.h"

#else

  #include <allegro.h>

  static void logerror(char* txt, ...)
  {


  }

#endif


#include <pc.h>
#include <conio.h>
#include <sys/farptr.h>
#include <go32.h>
#include <time.h>
#include <math.h>
#include <dpmi.h>
#include "g400__15.h"
#include "mode15k.h"
#include <stdio.h>



#define USE_ZOOM
//#define ZOOMLIMITATION
//#define ADJUST_VRATE



static int g_endofline = 0;
static int g_interlaceflag = 0;
static int g_valid = 0;

static void SetClockRegisterInternal(void);

static void SetG400ExtRegister(CRTCPARAM *cp);
static void SetInterlace(int flag, int HSyncStart, int HSyncEnd, int HTotal, int ratio);
static long get_vclk_param(unsigned long vclk, int *N, int *M, int *P, int *S);
static void SetVClock(int N, int M, int P, int S);
static void SetHZoom(int d0);
static int GetHorizontalZoomRatio(CRTCPARAM *cp);
static void AdjustCrtcParam(CRTCPARAM *cp, int hzoom);
static void AdjustSyncParam(CRTCPARAM *cp, long dotclock);
static int CheckHorizontalTotal(int HTotal, int hzoom);
static void SetCompositeSync(int flag);
static void SetDoubleScan(int flag);


static DWORD GetBytePerLine(void);
static void SetBytePerLine(DWORD d0);






WORD G400MMIO_inw(DWORD d0);
void G400MMIO_outw(DWORD d0, WORD d1);
BYTE G400MMIO_inb(DWORD d0);
void G400MMIO_outb(DWORD d0, BYTE d1);
void G400LFBWriteb(DWORD d0, BYTE d1);

BYTE G400IdxReg_inb(BYTE _index);
BYTE G400CrtcExtReg_inb(BYTE _index);
void G400IdxReg_outb(BYTE _index, BYTE _data);
void G400CrtcExtReg_outb(BYTE _index, BYTE _data);




/* extern */
extern int	_create_linear_mapping(unsigned long *linear, unsigned long physaddr, int size);
extern int	_create_selector(int *segment, unsigned long linear, int size);
extern void _remove_linear_mapping(unsigned long *linear);
extern void _remove_selector(int *segment);


unsigned long G400PhysicalAddress = 0;
unsigned long G400LinearAddress   = 0;
int   G400LinearSelector  = 0;

unsigned long G400LFBPhysicalAddress = 0;
unsigned long G400LFBLinearAddress	 = 0;
static int	 G400LFBLinearSelector	= 0;



int detectG400(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		logerror("PCI BIOS not Installed.\n");
		return 0;
	}

	r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
	r.d.ecx = 0x00000525;						// device ID
	r.d.edx = 0x0000102B;						// vendor ID
	r.d.esi = 0x00000000;						// device index
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return 0;
	}

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000014;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		logerror( "g400: Read Configuration DWORD error.\n");
		return 0;
	}

	logerror("G400 found\n");

	G400PhysicalAddress = r.d.ecx & 0xFFFFC000;
	logerror( "g400: MMIO Address %08lx\n", G400PhysicalAddress);

	if (_create_linear_mapping(&G400LinearAddress, G400PhysicalAddress, 0x10000) != 0){
		logerror( "g400: _create_linear_mapping error\n");
		return 0;
	}
	logerror( "g400: Linear Address %08lx\n", G400LinearAddress);

	if (_create_selector(&G400LinearSelector, G400LinearAddress, 0x10000) != 0) {
		_remove_linear_mapping(&G400LinearAddress);
		logerror( "g400: _create_selector error\n");
		return 0;
	}

#ifdef MAME
	DisableStretch();
#endif

	return 1;
}


void resetG400_15KHz(void)
{
	_remove_linear_mapping(&G400LinearAddress);
	_remove_selector(&G400LinearSelector);
	_remove_linear_mapping(&G400LFBLinearAddress);
	_remove_selector(&G400LFBLinearSelector);
}







int setG400(void)
{
	CRTCPARAM cp;
	int hzoom;
	int N, M, P, S;
	long vclk;
#ifdef ADJUST_VRATE
	int tempdt;
	int dtHTotal;
	long temp;
	long dt;
#endif

	if(GetMode15KHz(&cp) == 0) return 0;
	cp.HTotal += 8;
	hzoom = GetHorizontalZoomRatio(&cp);
	AdjustCrtcParam(&cp, hzoom);

#ifdef ADJUST_VRATE
	logerror( "desrate %d\n", (int)cp.vert001Hz);
	dtHTotal = 0;
	dt		 = 10000;	   // 100.00Hz
	tempdt	 = 0;
	for( tempdt = 0 ; tempdt < (hzoom * 8) ; tempdt += 8 ){
		if( CheckHorizontalTotal(cp.HTotal + tempdt, hzoom) == 0 )
			continue;
		vclk = CalcDotclock(cp.vert001Hz, cp.HTotal + tempdt,
								cp.VTotal, cp.interlace);
		vclk = get_vclk_param(vclk, &N, &M, &P, &S);
		temp = CalcVert001Hz(vclk, cp.HTotal + tempdt, cp.VTotal, cp.interlace);
		logerror( "refreshrate %d\n", (int)temp);
		temp = temp - cp.vert001Hz;
		logerror( "dt %d\n\n", (int)temp);
		if(temp < 0) temp *= -1;
		if(temp < dt){
			dt = temp;
			dtHTotal = tempdt;
		}
	}
	logerror( "dt %dHz\n", (int)dt);
	logerror( "dtHTotal %d\n", dtHTotal);
	cp.HTotal += dtHTotal;
	cp.HBEnd   = cp.HTotal - 8;
	vclk = CalcDotclock(cp.vert001Hz, cp.HTotal, cp.VTotal, cp.interlace);
	vclk = get_vclk_param(vclk, &N, &M, &P, &S);

#else

	vclk = get_vclk_param(cp.dotclockHz, &N, &M, &P, &S);

#endif

	AdjustSyncParam(&cp, vclk);
	DispCrtcParam(&cp);

	DisableGenerateSignal();
	SetGenericVGARegister(&cp);
	SetG400ExtRegister(&cp);
	SetVClock(N, M, P, S);
	SetHZoom(hzoom);
	SetDoubleScan(cp.doublescan);
//	  SetCompositeSync(cp.compositesync);
	SetHVPolarity(cp.hpolarity, cp.vpolarity);
	EnableGenerateSignal();

	return 1;
}



int setG400_15KHz(int vdouble, int width, int height)
{
	return setG400();
}


static int GetHorizontalZoomRatio(CRTCPARAM *cp)
{
	int zoom = 1;

#ifdef USE_ZOOM

	if(cp->HTotal < 512){
		zoom = 4;
	}else if(cp->HTotal < 1024){
		zoom = 2;
	}else{
		zoom = 1;
	}

#endif

	return zoom;
}


static void AdjustSyncParam(CRTCPARAM *cp, long dotclock)
{
	int d0;

	if(dotclock == 0){
		cp->dotclockHz = CalcDotclock(cp->vert001Hz, cp->HTotal,
											cp->VTotal, cp->interlace);
	}else{
		cp->dotclockHz = dotclock;
	}
	cp->horzHz	   = cp->dotclockHz / cp->HTotal;
	d0 = cp->VTotal * 2;
	if(cp->interlace != 0){
		d0 += 1;
	}
	cp->vert001Hz  = (cp->horzHz * 100 * 2) / d0;
}


static void AdjustCrtcParam(CRTCPARAM *cp, int hzoom)
{
	cp->HTotal	*= hzoom;
	cp->HDisp	*= hzoom;
	cp->HBStart *= hzoom;
	cp->HBEnd	*= hzoom;
	cp->HSStart *= hzoom;
	cp->HSEnd	*= hzoom;

	cp->HBStart = cp->HDisp - 8;
	cp->HBEnd	= cp->HTotal - 8;
	cp->VBStart = cp->VDisp  - 1;
	cp->VBEnd	= cp->VTotal - 1;


	if( (cp->HBEnd - cp->HBStart) > (0x7F << 3) ){
		cp->HBEnd = cp->HBStart + (0x7F << 3);
	}
	if( (cp->HSEnd - cp->HSStart) > (0x1F << 3) ){
		cp->HSEnd = cp->HSStart + (0x1F << 3);
	}

	if(cp->interlace != 0){
		if( (cp->VTotal % 2) != 0 ){
			cp->VTotal += 1;
			cp->VBEnd	= cp->VTotal - 1;
		}
	}

	if( CheckHorizontalTotal(cp->HTotal, hzoom) == 0 ){
		cp->HTotal += 8;
	}

	AdjustSyncParam(cp, 0);
}



static int CheckHorizontalTotal(int HTotal, int hzoom)
{
	int result = 1;
#ifdef ZOOMLIMITATION
	int d0;

	d0 = 8 * hzoom;
	if( ((HTotal >> 3) % d0)  ==  (d0 - 1) ){
		result = 0;
	}
#endif
	return result;
}


static void SetClockRegisterInternal(void)
{
	BYTE d0;

	d0 = _in(0x3CC);
	d0 = d0 | 0x0C;
	_out(0x3C2, d0);
}














static void SetInterlace(int flag, int HSyncStart, int HSyncEnd, int HTotal, int ratio)
{
	int d1;

	if(flag != 0){
		d1 = G400CrtcExtReg_inb(0x00);
		if((d1 & 0x80) == 0){
			d1 = (HSyncStart/8) + (HSyncEnd/8) - (HTotal/8);
			d1 = (d1 * ratio) / 100;
			d1 = (d1 / 2) - 1;
			if(d1 < 0)	  d1 = 0;
			if(d1 > 0xFF) d1 = 0xFF;
			G400CrtcExtReg_outb(0x05, d1 & 0xFF);
			G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 7, 1, 0));
			SetBytePerLine(GetBytePerLine() * 2);
		}
	}else{
		d1 = G400CrtcExtReg_inb(0x00);
		if((d1 & 0x80) != 0){
			G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 7, 0, 0));
			G400CrtcExtReg_outb(0x05, 0);
			SetBytePerLine(GetBytePerLine() / 2);
		}
	}
}



static DWORD GetBytePerLine(void)
{
	DWORD d0;

	d0 = GetCrtcReg(0x13);
	d0 = BitMov(d0, 8, G400CrtcExtReg_inb(0x00), 4);
	d0 = BitMov(d0, 9, G400CrtcExtReg_inb(0x00), 5);
	return d0;
}

static void SetBytePerLine(DWORD d0)
{
	SetCrtcReg(0x13, d0 & 0xFF);
	G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 4, d0, 8));
	G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 5, d0, 9));
}





void SetG400ExtRegister(CRTCPARAM *cp)
{
	int d0;

	d0 = 0;
	d0 = BitMov(d0, 0, (cp->HTotal	>> 3) - 5, 8);
	d0 = BitMov(d0, 1, (cp->HBStart >> 3)	 , 8);
	d0 = BitMov(d0, 2, (cp->HSStart >> 3)	 , 8);
	d0 = BitMov(d0, 6, (cp->HBEnd	>> 3)	 , 6);
	G400CrtcExtReg_outb(0x01, d0);

	d0 = 0;
	d0 = BitMov(d0, 0, cp->VTotal - 2, 10);
	d0 = BitMov(d0, 1, cp->VTotal - 2, 11);
	d0 = BitMov(d0, 2, cp->VDisp  - 1, 10);
	d0 = BitMov(d0, 3, cp->VBStart	 , 10);
	d0 = BitMov(d0, 4, cp->VBStart	 , 11);
	d0 = BitMov(d0, 5, cp->VSStart	 , 10);
	d0 = BitMov(d0, 6, cp->VSStart	 , 11);
	G400CrtcExtReg_outb(0x02, d0);

	SetInterlace(cp->interlace, cp->HSStart, cp->HSEnd, cp->HTotal, cp->interlaceratio);

	g_interlaceflag = cp->interlace;
	g_endofline = cp->VTotal;
	g_valid = 1;
}





#define BASE_FREQ 27000.0

static long get_vclk_param(unsigned long vclk, int *N, int *M, int *P, int *S)
{
	int d0;
	int d1;
	double fd;
	double dt;
	double tempfd;
	double tempdt;
	double ref = BASE_FREQ;
	double Fvco;

	vclk = vclk / 1000;
	*P = 0;
	if(vclk > 240000) vclk = 240000;
	if( 	 vclk <   30000){
		*P = 8;
	}else if(vclk <   60000){
		*P = 4;
	}else if(vclk <  120000){
		*P = 2;
	}else if(vclk <= 240000){
		*P = 1;
	}

	*N = 0;
	*M = 0;
	tempfd = 0;
	tempdt = 0;
	fd = vclk * (*P);
	dt = 240000;

	d0 = 8;
	while(d0 <= 128){
		d1 = 2;
		while(d1 <= 32){
			tempfd = ref * d0 / d1;
			tempdt = fd - tempfd;
			if(tempdt < 0) tempdt *= -1;
			if(dt > tempdt){
				*N = d0;
				*M = d1;
				dt = tempdt;
			}
			d1 += 1;
		}
		d0 += 1;
	}

	Fvco = ref * (*N) / (*M);
	tempfd = Fvco / (*P);

	*S = 0;
	if( 	 Fvco < 110000){
		*S = 0;
	}else if(Fvco < 170000){
		*S = 1;
	}else if(Fvco < 240000){
		*S = 2;
	}else if(Fvco < 310000){
		*S = 3;
	}

#if 1
	logerror( "N: %d\n", *N);
	logerror( "M: %d\n", *M);
	logerror( "P: %d\n", *P);
	logerror( "S: %d\n", *S);

	logerror( "Fd	%f\n", fd / (*P));
	logerror( "Fout %f\n", tempfd);
	logerror( "Fvco %f\n", Fvco);
#endif


	return (long)(tempfd * 1000);
}



static void SetVClock(int N, int M, int P, int S)
{
	int PLLn;

	G400IdxReg_outb(0x1A, BitMov(G400IdxReg_inb(0x1A), 2, 1, 0));

	PLLn = _in(0x3CC);
	PLLn = PLLn | 0x0C;
	_out(0x3C2, PLLn);

	M -= 1;
	N -= 1;
	P -= 1;

	M = M & 0x1F;
	G400IdxReg_outb(0x4C, M);
	N = N & 0x7F;
	G400IdxReg_outb(0x4D, N);
	P = P | (S << 3);
	P = P & 0x1F;
	G400IdxReg_outb(0x4E, P);

	while(1){
		if( (G400IdxReg_inb(0x4F) & 0x40) != 0 ) break;
	}

	G400IdxReg_outb(0x1A, BitMov(G400IdxReg_inb(0x1A), 2, 0, 0));

}




static void SetHZoom(int d0)
{
	if(d0 == 1){
		d0 = 0;
	}else if(d0 == 2){
		d0 = 1;
	}else if(d0 == 4){
		d0 = 3;
	}else{
		d0 = 0;
	}
	G400IdxReg_outb(0x38, d0);
}


static void SetCompositeSync(int flag)
{
	int d0;

	d0 = G400CrtcExtReg_inb(0x03);
	if(flag != 0){
		d0 = BitMov(d0, 6, 1, 0);
	}else{
		d0 = BitMov(d0, 6, 0, 0);
	}
	G400CrtcExtReg_outb(0x03, d0);
}

static void SetDoubleScan(int flag)
{
	int d0;

	d0 = GetCrtcReg(0x09) & ~0x1F;
	if(flag != 0){
		d0 = d0 | 0x01;
	}
	SetCrtcReg(0x09, d0);
}


int G400GetVerticalCount(void)
{
	return (int)_farpeekl(G400LinearSelector, 0x1E20);
}


static DWORD tasmania = 0;

static void w_enter_critical(void)
{
	tasmania += 1;
	if(tasmania == 1){
		asm volatile("cli");
	}
}

static void w_exit_critical(void)
{
	tasmania -= 1;
	if(tasmania == 0){
		asm volatile("sti");
	}
}




static void vga_vsync(void)
{
	w_enter_critical();
	while( (inportb(0x3da) & 0x08) != 0 );
	while( (inportb(0x3da) & 0x08) == 0 );
	w_exit_critical();
}

static void vesa_scroll(int x, int y)
{
	__dpmi_regs _dpmi_reg;

	_dpmi_reg.x.ax = 0x4F07;
	_dpmi_reg.x.bx = 0;
	_dpmi_reg.x.cx = x;
	_dpmi_reg.x.dx = y;
	__dpmi_int(0x10, &_dpmi_reg);
}


int G400Flip(int x, int y, int evenoddflag)
{
//
// evenoddflag
//		0	vsync
//		1	odd
//		2	even
//

	int curr;
	int prev;
	int line_;

	if(g_interlaceflag != 0) y = y / 2;

	prev = 0;
	vga_vsync();
	vesa_scroll(x, y);
	if( (g_valid != 0) && (g_interlaceflag != 0) &&
				((evenoddflag == 1) || (evenoddflag == 2)) ){
		if(evenoddflag == 1)
			line_ = g_endofline;
		else
			line_ = g_endofline - 1;
		w_enter_critical();
		while(1){
			curr = G400GetVerticalCount();
			if(curr < prev){
				if(prev == line_)
					break;
				else
					prev = 0;
			}else{
				prev = curr;
			}
		}
		w_exit_critical();
	}
	return 1;		// dummy
}









BYTE G400MMIO_inb(DWORD d0)
{
	return _farpeekb(G400LinearSelector, d0);
}

void G400MMIO_outb(DWORD d0, BYTE d1)
{
	_farpokeb(G400LinearSelector, d0, d1);
}

WORD G400MMIO_inw(DWORD d0)
{
	return _farpeekw(G400LinearSelector, d0);
}

void G400MMIO_outw(DWORD d0, WORD d1)
{
	_farpokew(G400LinearSelector, d0, d1);
}

BYTE G400IdxReg_inb(BYTE _index)
{
	_farpokeb(G400LinearSelector, 0x3C00, _index);
	return _farpeekb(G400LinearSelector, 0x3C0A);
}

void G400IdxReg_outb(BYTE _index, BYTE _data)
{
	_farpokeb(G400LinearSelector, 0x3C00, _index);
	_farpokeb(G400LinearSelector, 0x3C0A, _data);
}

BYTE G400CrtcExtReg_inb(BYTE _index)
{
	_farpokeb(G400LinearSelector, 0x1FDE, _index);
	return _farpeekb(G400LinearSelector, 0x1FDF);
}

void G400CrtcExtReg_outb(BYTE _index, BYTE _data)
{
	_farpokeb(G400LinearSelector, 0x1FDE, _index);
	_farpokeb(G400LinearSelector, 0x1FDF, _data);
}



void G400LFBWriteb(DWORD d0, BYTE d1)
{
	_farpokeb(G400LFBLinearSelector, d0, d1);
}
