//#define MAME

#ifdef MAME

  #include "mamalleg.h"
  #include "driver.h"

#else

  #include <allegro.h>

  static void logerror(char* txt, ...)
  {


  }

#endif





#include <pc.h>
#include <conio.h>
#include <sys/farptr.h>
#include <go32.h>
#include <time.h>
#include <math.h>
#include <dpmi.h>
#include "laguna15.h"
#include "mode15k.h"



BYTE LagunaMMIO_inb(DWORD d0);
void LagunaMMIO_outb(DWORD d0, BYTE d1);
WORD LagunaMMIO_inw(DWORD d0);
void LagunaMMIO_outw(DWORD d0, WORD d1);
void LagunaLFBWritel(DWORD d0, DWORD d1);

static void ClearLagunaHorzAdjustReg(void);
static DWORD GetLagunaBytePerPixel(void);
static void SetLagunaFetchesPerLine(DWORD d0);
static void LagunaZeroMemory(void);



static void SetLagunaExtRegister(CRTCPARAM *cp);
static int	GetLagunaBytePerLine(void);
static void SetLagunaBytePerLine(int d0);
static void SetLagunaInterlace(int flag, CRTCPARAM* cp);
static void SetLagunaVClock(int Num, int DeN, int PS);


static long GetLagunaVclkParam(long vclk, int *Num, int *DeN, int *PS);


static void SetDoubleScan(int flag);
static void SelectPLL(void);



/* extern */
extern int	_create_linear_mapping(unsigned long *linear, unsigned long physaddr, int size);
extern int	_create_selector(int *segment, unsigned long linear, int size);
extern void _remove_linear_mapping(unsigned long *linear);
extern void _remove_selector(int *segment);


unsigned long LagunaPhysicalAddress = 0;
unsigned long LagunaLinearAddress	= 0;
int   LagunaLinearSelector	= 0;

unsigned long LagunaLFBPhysicalAddress = 0;
unsigned long LagunaLFBLinearAddress   = 0;
int   LagunaLFBLinearSelector  = 0;







int detectLaguna(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		logerror("15.75KHz: PCI BIOS not Installed.\n");
		return 0;
	}

	while(1){
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x000000D0;						// device ID
		r.d.edx = 0x00001013;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("laguna: CL-GD5462 Found\n");
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x000000D4;						// device ID
		r.d.edx = 0x00001013;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("laguna: CL-GD5464 Found\n");
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x000000D6;						// device ID
		r.d.edx = 0x00001013;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("laguna: CL-GD5465 Found\n");
			break;
		}

		logerror("Laguna not found\n");
		return 0;
	}

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000014;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		logerror("laguna: Read Configuration DWORD error.\n");
		return 0;
	}
	LagunaPhysicalAddress = r.d.ecx & 0xffff8000;
	logerror("laguna: MMIO Address %08lx\n", LagunaPhysicalAddress);

	if (_create_linear_mapping(&LagunaLinearAddress, LagunaPhysicalAddress, 0x10000) != 0){
		logerror("laguna: _create_linear_mapping error\n");
		return 0;
	}
	logerror("laguna: Linear Address %08lx\n", LagunaLinearAddress);

	if (_create_selector(&LagunaLinearSelector, LagunaLinearAddress, 0x10000) != 0) {
		_remove_linear_mapping(&LagunaLinearAddress);
		logerror("laguna: _create_selector error\n");
		return 0;
	}

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000010;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		logerror("laguna: Read Configuration DWORD error.\n");
		return 0;
	}
	LagunaLFBPhysicalAddress = r.d.ecx & 0xFE000000;
	logerror("laguna: LFB Address %08lx\n", LagunaLFBPhysicalAddress);
	if (_create_linear_mapping(&LagunaLFBLinearAddress, LagunaLFBPhysicalAddress, 32 * 1024 * 1024) != 0){
		logerror("laguna: _create_linear_mapping error\n");
		return 0;
	}
	logerror("laguna: LFB Linear Address %08lx\n", LagunaLFBLinearAddress);

	if (_create_selector(&LagunaLFBLinearSelector, LagunaLFBLinearAddress, 32 * 1024 * 1024) != 0) {
		_remove_linear_mapping(&LagunaLFBLinearAddress);
		logerror("laguna: _create_selector error\n");
		return 0;
	}

#ifdef MAME
	DisableStretch();
#endif

	return 1;
}


void resetLaguna_15KHz(void)
{
	_remove_linear_mapping(&LagunaLinearAddress);
	_remove_selector(&LagunaLinearSelector);
	_remove_linear_mapping(&LagunaLFBLinearAddress);
	_remove_selector(&LagunaLFBLinearSelector);
}



int setLaguna(void)
{
	CRTCPARAM cp;
	int Num;
	int DeN;
	int PS;

	if(GetMode15KHz(&cp) == 0) return 0;
	cp.dotclockHz = GetLagunaVclkParam(cp.dotclockHz, &Num, &DeN, &PS);
	cp.vert001Hz  = CalcVert001Hz(cp.dotclockHz, cp.HTotal,
								  cp.VTotal, cp.interlace);
	cp.horzHz	  = CalcHorizontalHz(cp.dotclockHz, cp.HTotal);

	cp.HBStart = cp.HSStart;
	cp.HBEnd   = cp.HTotal - 8;
	cp.VBStart = cp.VDisp;
	cp.VBEnd   = cp.VTotal - 1;

	DispCrtcParam(&cp);

	DisableGenerateSignal();
	SetGenericVGARegister(&cp);
	SetLagunaExtRegister(&cp);
	SetLagunaVClock(Num, DeN, PS);
	ClearLagunaHorzAdjustReg();
	SetLagunaFetchesPerLine(GetLagunaBytePerPixel() * cp.HDisp);
	LagunaZeroMemory();
	EnableGenerateSignal();

	return 1;
}

int setLaguna_15KHz(int vdouble, int width, int height)
{
	return setLaguna();
}





static void SelectPLL(void)
{
	BYTE d0;

	d0 = _in(0x3CC);
	d0 = d0 | 0x0C;
	_out(0x3C2, d0);
}





void SetLagunaExtRegister(CRTCPARAM *cp)
{
	int d0;

	d0 = GetCrtcReg(0x1B);
	d0 = BitMov(d0, 5, 1, 0);
	d0 = BitMov(d0, 7, 1, 0);
	SetCrtcReg(0x1B, d0);						// enable Blank End ext

	d0 = 0;
	d0 = BitMov(d0, 0, cp->VSStart			 , 10);
	d0 = BitMov(d0, 1, cp->VBStart			 , 10);
	d0 = BitMov(d0, 2, cp->VDisp			 , 10);
	d0 = BitMov(d0, 3, cp->VTotal			 , 10);
	d0 = BitMov(d0, 4, (cp->HSStart >> 3)	 , 8);
	d0 = BitMov(d0, 5, (cp->HBStart >> 3)	 , 8);
	d0 = BitMov(d0, 6, (cp->HDisp	>> 3) - 1, 8);
	d0 = BitMov(d0, 7, (cp->HTotal	>> 3) - 5, 8);
	SetCrtcReg(0x1E, d0);						// ext horz vert reg

	d0 = GetCrtcReg(0x1A);
	d0 = BitMov(d0, 4, (cp->HBEnd >> 3) 	 , 6);
	d0 = BitMov(d0, 5, (cp->HBEnd >> 3) 	 , 7);
	d0 = BitMov(d0, 6, cp->VBEnd			 , 8);
	d0 = BitMov(d0, 7, cp->VBEnd			 , 9);
	SetCrtcReg(0x1A, d0);						// ext Blank End reg




	SetDoubleScan(cp->doublescan);
	SetLagunaInterlace(cp->interlace, cp);
	SetHVPolarity(cp->hpolarity, cp->vpolarity);
}






static int GetLagunaBytePerLine(void)
{
	DWORD d0;

	d0	= (DWORD)GetCrtcReg(0x19);
	d0 |= (DWORD)((GetCrtcReg(0x51) << 4) & 0x0300);
	d0 = d0 << 3;
	return d0;
}

static void SetLagunaBytePerLine(int d0)
{
	BYTE d1;

	d0 = d0 >> 3;
	d1 = (BYTE)(d0 & 0xFF);
	SetCrtcReg(0x19, d1);
	d1 = GetCrtcReg(0x51) & ~0x30;
	d1 = d1 | ((d0 >> 4) & 0x30);
	SetCrtcReg(0x51, d1);
}


static void SetDoubleScan(int flag)
{
	if(flag == 0){
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 0, 0));
	}else{
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 1, 0));
	}
}


static void SetLagunaInterlace(int flag, CRTCPARAM *cp)
{
	int d0;

	if(flag == 0){
		d0 = GetCrtcReg(0x1A);
		if((d0 & 0x01) != 0){
			d0 = d0 & ~0x01;
			SetCrtcReg(0x1A, d0);
		}
	}else{
		d0 = ((cp->HTotal >> 3) - 5) / 2;
		d0 = (d0 * cp->interlaceratio) / 100;
		SetCrtcReg(0x19, d0);						// interlace offset
		d0 = GetCrtcReg(0x1A);
		if((d0 & 0x01) == 0){
			d0 = d0 | 0x01;
			SetCrtcReg(0x1A, d0);
		}
	}
}


static void ClearLagunaHorzAdjustReg(void)
{
	BYTE d0;

	d0 = LagunaMMIO_inb(0x70);
	d0 = d0 & 0xC0;
	LagunaMMIO_outb(0x70, d0);
}

static DWORD GetLagunaBytePerPixel(void)
{
	DWORD d0;

	d0 = (LagunaMMIO_inw(0xC0) >> 12) & 0x03;
	d0 += 1;
	return d0;
}

static void SetLagunaFetchesPerLine(DWORD d0)
{
	WORD d1;

	d0 = d0 + 127;
	d0 = d0 / 128;
	d0 = d0 & 0x3F;
	d1 = LagunaMMIO_inw(0xEA) & ~0x3F00;
	d1 = d1 | (d0 << 8);
	LagunaMMIO_outw(0xEA, d1);
}

static void LagunaZeroMemory(void)
{
	__dpmi_regs 	r;
	DWORD installedmemory;
	int loopcounter;

	r.h.ah = 0x12;
	r.h.bl = 0x85;
	__dpmi_int(0x10, &r);
	installedmemory = r.h.al * 65536;
	logerror("laguna: Installed Memory %d MByte\n", installedmemory / (1024 * 1024) );

	loopcounter = 0;
	while(loopcounter < installedmemory){
		LagunaLFBWritel(loopcounter, 0);
		loopcounter += 4;
	}
}




static long GetLagunaVclkParam(long vclk, int *Num, int *DeN, int *PS)
{
	double desfreq;
	double temp;
	double tempdt;
	double dt;
	int d0;
	int d1;

	if(vclk > 175000000) vclk = 175000000;
	*PS 	= 1;
	if(vclk >=	75000000){
		*PS  = 1;
	}else if(vclk >=  37500000){
		*PS  = 2;
	}else if(vclk >=  13500000){
		*PS  = 4;
	}else{
		*PS  = 8;
	}

	desfreq = vclk * (*PS);
	dt = 250000000.0;
	*Num = 0;
	*DeN = 0;
	d0 = 2;
	while(d0 < 126){
		d1 = 2;
		while(d1 < 126){
			temp   = 14318000 * (double)d0 / d1;
			tempdt = desfreq - temp;
			if(tempdt < 0) tempdt *= -1;
			if(tempdt < dt){
				*Num = d0;
				*DeN = d1;
				dt = tempdt;
			}
			d1 += 1;
		}
		d0 += 1;
	}
	logerror("Num %3d, DeN %3d, PS %1d\n", *Num, *DeN, *PS);
	logerror("14.318 * (Num/DeN) : %lf\n", 14.318 *((*Num)/(*DeN)));
	logerror("14.318 * (Num/DeN)/PS : %lf\n", 14.318 * ((double)(*Num)/(*DeN))
													/ (*PS));
	vclk = 14318000 * ((double)(*Num)/(*DeN) / (*PS));
	logerror("vclk : %lf\n", (double)vclk / 1000000.0);

	return vclk;
}



static void SetLagunaVClock(int Num, int DeN, int PS)
{
	DWORD _PS;
	WORD d0;
	BYTE _Num;
	BYTE _DeN;


	SelectPLL();

	_PS = 0;
	while(1){
		PS = PS >> 1;
		if(PS == 0) break;
		_PS += 1;
	}

	_Num = Num & 0x7F;
	_DeN = DeN << 1;
	SetSeqReg(0x1E, _Num);
	SetSeqReg(0x0E, _DeN);

	d0 = LagunaMMIO_inw(0xC0) & ~0xC000;
	d0 = d0 | (_PS << 14);
	LagunaMMIO_outw(0xC0, d0);
}



BYTE LagunaMMIO_inb(DWORD d0)
{
	return _farpeekb(LagunaLinearSelector, d0);
}

void LagunaMMIO_outb(DWORD d0, BYTE d1)
{
	_farpokeb(LagunaLinearSelector, d0, d1);
}

WORD LagunaMMIO_inw(DWORD d0)
{
	return _farpeekw(LagunaLinearSelector, d0);
}

void LagunaMMIO_outw(DWORD d0, WORD d1)
{
	_farpokew(LagunaLinearSelector, d0, d1);
}

void LagunaLFBWritel(DWORD d0, DWORD d1)
{
	_farpokel(LagunaLFBLinearSelector, d0, d1);
}
