/*												*/
/*		scrlist.c								*/
/*			By	suzuki2go.						*/
/*												*/

#include "driver.h"
#include "mode15k.h"




/*	PAL TEST  */

static CRTCPARAM mode768x576_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	 1048, 768, 768, 856, 936,1040,   312, 288, 288, 289, 295, 311,

// width height HPlr VPlr DblScn Intrlc Iratio
	 768,	576,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   16375000,  15625,   5000
};



static CRTCPARAM mode400x288_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 448, 472, 528,   313, 288, 288, 289, 295, 312,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8388400,  15650,   5000
};



static CRTCPARAM mode384x288_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 384, 384, 440, 480, 528,   313, 288, 288, 289, 295, 312,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8388400,  15650,   5000
};



static CRTCPARAM mode320x288_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  432, 320, 320, 360, 392, 424,   313, 288, 288, 289, 292, 312,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6760800,  15650,   5000
};



/*	For PC monitor	*/

static CRTCPARAM mode640x480_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  800, 640, 640, 672, 768, 792,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25248000,  31560,   6000
};



static CRTCPARAM mode320x240_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  400, 320, 320, 344, 368, 392,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12624000,  31560,   6000
};



static CRTCPARAM mode400x300_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 432, 480, 520,   632, 600, 600, 602, 610, 631,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	300,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   20021760,  37920,   6000
};



static CRTCPARAM mode800x600_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	 1056, 800, 800, 864, 960,1048,   632, 600, 600, 602, 610, 631,

// width height HPlr VPlr DblScn Intrlc Iratio
	 800,	600,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   40043520,  37920,   6000
};



static CRTCPARAM mode1024x768_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	 1280,1024,1024,1040,1128,1272,   800, 768, 768, 770, 780, 799,

// width height HPlr VPlr DblScn Intrlc Iratio
	1024,	768,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   61440000,  48000,   6000
};



static CRTCPARAM mode512x384_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 512, 512, 520, 552, 640,   800, 768, 768, 770, 780, 799,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	384,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   31104000,  48000,   6000
};



/* Horizontal 31kHz */

static CRTCPARAM mode640x480_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  800, 640, 640, 672, 768, 792,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25248000,  31560,   6000
};



static CRTCPARAM mode512x480_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  640, 512, 512, 544, 584, 632,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   20198400,  31560,   6000
};



static CRTCPARAM mode512x384_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 512, 512, 544, 584, 640,   525, 384, 384, 435, 438, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	384,   1,	0,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   20412000,  31500,   6000
};



static CRTCPARAM mode480x480_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  600, 480, 480, 512, 552, 592,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   18936000,  31560,   6000
};



static CRTCPARAM mode384x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  480, 384, 384, 408, 448, 472,   528, 480, 480, 481, 484, 527,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   15206400,  31680,   6000
};



static CRTCPARAM mode320x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  400, 320, 320, 344, 368, 392,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12624000,  31560,   6000
};



static CRTCPARAM mode288x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  360, 288, 288, 312, 336, 352,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 288,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   11361600,  31560,   6000
};



static CRTCPARAM mode256x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 256, 256, 280, 304, 312,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10099200,  31560,   6000
};



/* Horizontal 24kHz */

static CRTCPARAM mode512x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  712, 512, 512, 600, 640, 704,   414, 384, 384, 383, 387, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   17686080,  24840,   6000
};



static CRTCPARAM mode496x384_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  704, 496, 496, 592, 632, 696,   428, 384, 384, 390, 394, 427,

// width height HPlr VPlr DblScn Intrlc Iratio
	 496,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   17476096,  24824,   5800
};



static CRTCPARAM mode456x384_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 456, 456, 544, 584, 640,   452, 384, 384, 401, 405, 451,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   16109280,  24860,   5500
};



static CRTCPARAM mode432x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 432, 432, 512, 552, 600,   414, 384, 384, 383, 387, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   15102720,  24840,   6000
};



static CRTCPARAM mode400x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  560, 400, 400, 472, 512, 552,   414, 384, 384, 383, 387, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13910400,  24840,   6000
};



/* Horizontal 15kHz */

static CRTCPARAM mode672x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  896, 672, 672, 736, 808, 888,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 672,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   14138880,  15780,   6000
};



static CRTCPARAM mode640x512_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  864, 640, 640, 704, 784, 856,   276, 256, 256, 255, 257, 275,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	512,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13617072,  15760,   5700
};



static CRTCPARAM mode640x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  864, 640, 640, 704, 784, 856,   262, 240, 240, 241, 243, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13608000,  15750,   6000
};



static CRTCPARAM mode640x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  864, 640, 640, 704, 784, 856,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13633920,  15780,   6000
};



static CRTCPARAM mode512x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  688, 512, 512, 568, 632, 680,   262, 240, 240, 241, 243, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10836000,  15750,   6000
};



static CRTCPARAM mode512x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  680, 512, 512, 560, 616, 672,   277, 256, 256, 256, 258, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10736520,  15789,   5700
};



static CRTCPARAM mode512x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  680, 512, 512, 560, 616, 672,   287, 256, 256, 261, 263, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10733800,  15785,   5500
};



static CRTCPARAM mode512x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  688, 512, 512, 568, 624, 680,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10856640,  15780,   6000
};



static CRTCPARAM mode480x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 480, 480, 536, 592, 640,   262, 240, 240, 241, 243, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10206000,  15750,   6000
};



static CRTCPARAM mode480x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  632, 480, 480, 512, 568, 624,   274, 256, 256, 255, 257, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10390080,  16440,   6000
};



static CRTCPARAM mode480x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  640, 480, 480, 528, 584, 632,   278, 256, 256, 257, 259, 277,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10141440,  15846,   5700
};



static CRTCPARAM mode456x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 504, 552, 600,   287, 256, 256, 260, 262, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9597280,  15785,   5500
};



static CRTCPARAM mode456x256_55_S = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  616, 456, 456, 496, 552, 608,   298, 256, 256, 265, 267, 297,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10096240,  16390,   5500
};



static CRTCPARAM mode456x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 504, 552, 600,   276, 240, 240, 248, 250, 275,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9565056,  15732,   5700
};



static CRTCPARAM mode432x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  568, 432, 432, 464, 520, 560,   273, 256, 256, 255, 257, 272,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9303840,  16380,   6000
};



static CRTCPARAM mode432x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  568, 432, 432, 472, 520, 560,   265, 240, 240, 243, 245, 264,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9031200,  15900,   6000
};



static CRTCPARAM mode432x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  568, 432, 432, 472, 520, 560,   275, 240, 240, 247, 249, 274,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9059600,  15950,   5800
};



static CRTCPARAM mode400x304_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 432, 480, 520,   329, 304, 304, 303, 305, 328,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	304,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8685600,  16450,   5000
};



static CRTCPARAM mode400x288_54 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 432, 480, 520,   306, 288, 288, 287, 289, 305,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8692358,  16462,   5380
};



static CRTCPARAM mode400x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 432, 488, 520,   273, 256, 256, 255, 257, 272,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8648640,  16380,   6000
};



static CRTCPARAM mode400x256_54 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  544, 400, 400, 448, 480, 536,   295, 256, 256, 265, 267, 294,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8633824,  15871,   5380
};



static CRTCPARAM mode400x256_53 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  544, 400, 400, 448, 480, 536,   298, 256, 256, 266, 268, 297,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8624358,  15853,   5320
};



static CRTCPARAM mode400x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  544, 400, 400, 448, 496, 536,   264, 240, 240, 241, 243, 263,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8616960,  15840,   6000
};



static CRTCPARAM mode384x280_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  512, 384, 384, 416, 464, 504,   328, 280, 280, 292, 295, 327,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	280,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8396800,  16400,   5000
};



static CRTCPARAM mode384x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  520, 384, 384, 432, 472, 512,   287, 256, 256, 260, 262, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8208200,  15785,   5500
};



static CRTCPARAM mode384x256_55_S = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  512, 384, 384, 416, 472, 504,   298, 256, 256, 265, 267, 297,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8391680,  16390,   5500
};



static CRTCPARAM mode384x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  520, 384, 384, 432, 472, 512,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8205600,  15780,   6000
};



static CRTCPARAM mode384x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  520, 384, 384, 432, 472, 512,   263, 224, 224, 234, 236, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8205600,  15780,   6000
};



static CRTCPARAM mode368x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  488, 368, 368, 408, 448, 480,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 368,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7700640,  15780,   6000
};



static CRTCPARAM mode360x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  480, 360, 360, 400, 448, 472,   277, 256, 256, 256, 258, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 360,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7578720,  15789,   5700
};



static CRTCPARAM mode352x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  472, 352, 352, 392, 432, 464,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 352,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7448160,  15780,   6000
};



static CRTCPARAM mode344x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  456, 344, 344, 376, 424, 448,   271, 256, 256, 255, 257, 270,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7414560,  16260,   6000
};



static CRTCPARAM mode344x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  464, 344, 344, 384, 424, 456,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7321920,  15780,   6000
};



static CRTCPARAM mode336x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  448, 336, 336, 376, 408, 440,   262, 240, 240, 241, 243, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 336,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7042560,  15720,   6000
};



static CRTCPARAM mode320x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  432, 320, 320, 360, 400, 424,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6816960,  15780,   6000
};



static CRTCPARAM mode320x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  432, 320, 320, 360, 400, 424,   272, 240, 240, 245, 247, 271,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6815232,  15776,   5800
};



static CRTCPARAM mode320x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  432, 320, 320, 360, 400, 424,   277, 240, 240, 248, 250, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6820848,  15789,   5700
};



static CRTCPARAM mode320x240_56 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  432, 320, 320, 360, 392, 424,   282, 240, 240, 250, 252, 281,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6822144,  15792,   5600
};



static CRTCPARAM mode320x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  432, 320, 320, 360, 400, 424,   263, 224, 224, 234, 236, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6816960,  15780,   6000
};



static CRTCPARAM mode304x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 336, 376, 400,   273, 256, 256, 255, 257, 272,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6683040,  16380,   6000
};



static CRTCPARAM mode304x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 344, 376, 400,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6438240,  15780,   6000
};



static CRTCPARAM mode304x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 344, 376, 400,   277, 240, 240, 248, 250, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6441912,  15789,   5700
};



static CRTCPARAM mode296x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  400, 296, 296, 336, 368, 392,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 296,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6312000,  15780,   6000
};



static CRTCPARAM mode288x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  392, 288, 288, 328, 360, 384,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 288,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6185760,  15780,   6000
};



static CRTCPARAM mode288x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  392, 288, 288, 328, 360, 384,   263, 224, 224, 234, 236, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 288,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6185760,  15780,   6000
};



static CRTCPARAM mode280x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  384, 280, 280, 320, 352, 376,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 280,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6059520,  15780,   6000
};



static CRTCPARAM mode272x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  360, 272, 272, 304, 336, 352,   264, 240, 240, 241, 243, 263,

// width height HPlr VPlr DblScn Intrlc Iratio
	 272,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5702400,  15840,   6000
};



static CRTCPARAM mode272x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  360, 272, 272, 304, 336, 352,   264, 224, 224, 234, 236, 263,

// width height HPlr VPlr DblScn Intrlc Iratio
	 272,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5702400,  15840,   6000
};



static CRTCPARAM mode264x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  352, 264, 264, 296, 328, 344,   264, 240, 240, 241, 243, 263,

// width height HPlr VPlr DblScn Intrlc Iratio
	 264,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5575680,  15840,   6000
};



static CRTCPARAM mode256x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  336, 256, 256, 280, 312, 328,   273, 256, 256, 255, 257, 272,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5503680,  16380,   6000
};



static CRTCPARAM mode256x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   278, 256, 256, 256, 258, 277,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5451024,  15846,   5700
};



static CRTCPARAM mode256x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   289, 256, 256, 260, 262, 288,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5467880,  15895,   5500
};



static CRTCPARAM mode256x256_55_S = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  336, 256, 256, 280, 312, 328,   298, 256, 256, 265, 267, 297,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5507040,  16390,   5500
};



static CRTCPARAM mode256x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   264, 240, 240, 241, 243, 263,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5448960,  15840,   6000
};



static CRTCPARAM mode256x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   274, 240, 240, 245, 247, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5466848,  15892,   5800
};



static CRTCPARAM mode256x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   279, 240, 240, 248, 250, 278,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5470632,  15903,   5700
};



static CRTCPARAM mode256x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   264, 224, 224, 234, 236, 263,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5448960,  15840,   6000
};



static CRTCPARAM mode240x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 240, 240, 264, 304, 312,   273, 256, 256, 255, 257, 272,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5241600,  16380,   6000
};



static CRTCPARAM mode240x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 240, 240, 272, 296, 312,   277, 256, 256, 255, 257, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5052480,  15789,   5700
};



static CRTCPARAM mode240x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 240, 240, 272, 296, 312,   263, 240, 240, 241, 243, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5049600,  15780,   6000
};



static CRTCPARAM mode240x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 240, 240, 272, 296, 312,   272, 240, 240, 246, 248, 271,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5048320,  15776,   5800
};



static CRTCPARAM mode240x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 240, 240, 272, 296, 312,   277, 240, 240, 248, 250, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5052480,  15789,   5700
};



static CRTCPARAM mode256x224_54 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   297, 224, 224, 250, 252, 296,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5496638,  15978,   5380
};





SCRLIST ScrModeList[] = {
	{ 640, 480, &mode640x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 480, &mode512x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 384, &mode512x384_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 480, 480, &mode480x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 240, &mode384x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 224, &mode384x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	 //
	{ 320, 240, &mode320x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 224, &mode320x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	 //
	{ 288, 240, &mode288x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 288, 224, &mode288x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	 //
	{ 256, 240, &mode256x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 256, 224, &mode256x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	 //

	{ 512, 384, &mode512x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 496, 384, &mode496x384_58    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 384, &mode432x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 384, &mode400x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },

	{ 672, 240, &mode672x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 512, &mode640x512_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 480, &mode640x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 240, &mode640x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 480, &mode512x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 256, &mode512x256_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 256, &mode512x256_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 240, &mode512x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 480, 480, &mode480x480_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 480, 256, &mode480x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 480, 256, &mode480x256_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 256, &mode456x256_55_S  , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 256, &mode456x256_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 240, &mode456x240_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 256, &mode432x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 240, &mode432x240_58    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 304, &mode400x304_50    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 288, &mode400x288_54    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 256, &mode400x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 256, &mode400x256_54    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 256, &mode400x256_53    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 240, &mode400x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 280, &mode384x280_50    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 256, &mode384x256_55_S  , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 256, &mode384x256_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 240, &mode384x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 224, &mode384x224_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 368, 240, &mode368x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 360, 256, &mode360x256_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 352, 240, &mode352x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 256, &mode344x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 240, &mode344x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 336, 240, &mode336x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_58    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_56    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 224, &mode320x224_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 304, 256, &mode304x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 304, 240, &mode304x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 304, 240, &mode304x240_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 296, 240, &mode296x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 292, 240, &mode296x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },	 //
	{ 288, 240, &mode288x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 288, 224, &mode288x224_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 280, 240, &mode280x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 272, 240, &mode272x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 272, 224, &mode272x224_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 264, 240, &mode264x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 264, 232, &mode264x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },	 //
	{ 256, 256, &mode256x256_60    , SPECIAL15KHz , SCREEN_HORZ },
	{ 256, 256, &mode256x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 256, &mode256x256_55_S  , SPECIAL15KHz , SCREEN_HORZ },
	{ 256, 256, &mode256x256_55    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 240, &mode256x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, 240, &mode256x240_58    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 240, &mode256x240_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 224, &mode256x224_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, 224, &mode256x224_54    , MODE15KHz	  , SCREEN_HORZ },
	{ 248, 256, &mode256x256_57    , MODE15KHz	  , SCREEN_HORZ },				 //
	{ 240, 256, &mode240x256_60    , SPECIAL15KHz , SCREEN_HORZ },
	{ 240, 256, &mode240x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 240, 248, &mode240x256_57    , MODE15KHz	  , SCREEN_HORZ },				 //
	{ 240, 240, &mode240x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 240, 240, &mode240x240_58    , MODE15KHz	  , SCREEN_HORZ },
	{ 240, 240, &mode240x240_57    , MODE15KHz	  , SCREEN_HORZ },

	{ 480, 512, &mode640x512_57    , MODE15KHz	  , SCREEN_VERT },
	{ 480, 480, &mode640x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 256, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_VERT },
	{ 240, 384, &mode432x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 384, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 240, 320, &mode432x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 320, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 304, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 304, &mode400x304_50    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 288, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 288, &mode400x288_54    , SPECIAL15KHz , SCREEN_VERT },
	{ 256, 480, &mode512x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 256, 256, &mode456x256_55_S  , SPECIAL15KHz , SCREEN_VERT },
	{ 256, 256, &mode456x256_55    , MODE15KHz	  , SCREEN_VERT },
	{ 240, 256, &mode432x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 256, &mode400x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 256, &mode400x256_54    , MODE15KHz	  , SCREEN_VERT },
	{ 192, 256, &mode344x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 256, 240, &mode456x240_57    , MODE15KHz	  , SCREEN_VERT },
	{ 240, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 240, &mode432x240_58    , MODE15KHz	  , SCREEN_VERT },
	{ 224, 240, &mode400x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 192, 240, &mode344x240_60    , STRICT15KHz  , SCREEN_VERT },
	{	0,	 0, &mode640x480_60    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT }
};


SCRLIST AutoResolutionList[] = {
	{ 320, 288, &mode320x288_50    , PAL15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 288, &mode384x288_50    , PAL15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 288, &mode400x288_50    , PAL15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 768, 576, &mode768x576_50    , PAL15KHz	  , SCREEN_HORZ | SCREEN_VERT },

	{ 320, 240, &mode320x240_forpc , PCMONITOR	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 300, &mode400x300_forpc , PCMONITOR	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 384, &mode512x384_forpc , PCMONITOR	  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 480, &mode640x480_forpc , PCMONITOR	  , SCREEN_HORZ | SCREEN_VERT },
	{ 800, 600, &mode800x600_forpc , PCMONITOR	  , SCREEN_HORZ | SCREEN_VERT },
	{1024, 768, &mode1024x768_forpc, PCMONITOR	  , SCREEN_HORZ | SCREEN_VERT },

	{ 240, 240, &mode240x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, 240, &mode256x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 256, 256, &mode432x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 264, 256, &mode264x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 272, 256, &mode272x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 280, 256, &mode280x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 288, 256, &mode288x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 296, 256, &mode296x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 304, 256, &mode304x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 320, 256, &mode320x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 336, 256, &mode336x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 352, 256, &mode352x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 360, 256, &mode360x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 368, 256, &mode368x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 384, 256, &mode384x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 400, 256, &mode400x256_53    , MODE15KHz	  , SCREEN_HORZ },
	{ 512, 240, &mode512x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 256, &mode512x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 640, 256, &mode640x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 672, 256, &mode672x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, 320, &mode432x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 256, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_VERT },
	{ 496, 384, &mode496x384_58    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 384, &mode512x384_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 384, &mode512x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 480, &mode512x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 480, &mode512x480_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 640, 480, &mode640x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 480, &mode640x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 480, 640, &mode640x512_57    , MODE15KHz	  , SCREEN_VERT },
	{	0,	 0, &mode640x480_60    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT }
};
